	list p=16f73
	include "p16f73.inc"
	__config  _hs_osc & _wdt_off & _pwrte_on 
	
BANK0RAM EQU H'20'


	cblock BANK0RAM
AD1
ADUSER
time1
time2
TEMP
FIN
CONFU
A
B3
C3
REM
COUNT1
COUNT
count0							
counter	
counter1
A1
B1						
C1
C2
B2
A2
RANGE

	endc

RS    equ     h'02'            
E     equ     h'05'            
RW    equ     h'04'		
rc0   equ	  h'00'			 

    org 0x000
	goto mainline
    org 0x004
	goto int
	

 
mainline
     bsf STATUS,RP0
     movlw b'00001010'    ;to set ra1(present)& ra3(user-defined) as 
     					  ;i/p pins&ra2,ra4,ra5 as o/p control to lcd
     movwf TRISA
     CLRF TRISC           ;PORTC AS OUTPUT DATA PORT TO LCD
     clrf trisb
     movlw b'00000100'    ;to set analog i/p(ra1&ra3),vref(Vcc)
     					  ;dig i/p(ra3,ra4&ra5)   
     movwf ADCON1
     bcf STATUS,RP0       ;to go to bank0
  
 ;*** LCD Initialization
			
initialize
			
		clrf	count0    ;all these are delay loops
		clrf 	counter
		call    mscounter
		call	t48us
		call	functionset
		call	character_entry
		call 	clear_display
		call	displayon

begin                     ;beginning the proper function
		call 	display            
		call 	present
	    CALL 	CHECK
        BTFSC 	STATUS,0
	    CALL 	HUNDREDS
	    CALL 	TENS
	    goto 	SUBTRACT
	    
;*** 150ms counter before LCD initializaion

mscounter
		movlw   d'300'          
        movwf   time1           
loop1   movlw   d'124'          
        movwf   time2           
loop2   nop                     
        decfsz  time2,f         
        goto    loop2           
        decfsz  time1,f         
        goto    loop1           
		return

;*** 48us Delay Loop for LCD initialization

t48us
        movlw   d'400'			
		movwf   count0			
t_loop
		call    t12us           
		decfsz  count0,f		
		goto	t_loop			
		return

;*** Character Entry Command for LCD

character_entry
		bcf		porta,RS		
		bcf 	porta,RW		
		movlw	h'06'			
		movwf	portc			
		call	pulse_e
		call	t48us	
		return
		
;*** Clear Display Command for LCD

clear_display

		bcf		porta,RS		
		bcf 	porta,RW		
		movlw	h'1'			
		movwf	portc			 
		call	pulse_e			
		call	t48us	
		return

;*** Function Set Command for LCD

functionset

		bcf		porta,RS		
		bcf 	porta,RW		
		movlw 	h'38'			
		movwf	portc			 	
		call 	pulse_e
		call 	t48us
		return

;*** Display On/Off & Cursor Command for LCD

displayon
		
		bcf		porta,RS		
		bcf 	porta,RW		
		movlw 	d'12'			
		movwf	portc				
		call 	pulse_e			
		call 	t48us
		return		
    
display
		movlw	d'8'			
		movwf	counter
message					
		movf	counter,w   	
		sublw	d'8'		;Subtract character count from 19 
							;& store result in W
		call	text			
		bsf		porta,RS	;RS  line to 1 to i/p Data
		bcf 	porta,RW	;R/W line to 0 to write
		movwf	portc		;send character to LCD
		call 	pulse_e		;Clock the LCD
		call	t48us		;delay for LCD busy
		decfsz	counter,f	;counter - 1 = 0 ? 
							;Are all characters displayed ?
		goto	message		;No.  Display the next character
		return				;Yes. Goto Initialize


;*** Clocking for LCD

pulse_e
		bsf		porta,E			 
		nop
		bcf		porta,E			
		retlw	h'0'

;*** Initialization Display Data for LCD

text
		addwf	02,f		;Store (PC+W) in PC(addr $02) to jump forward
		retlw   h'54'       ;ascii for t 
		retlw	h'65'		;ASCII for e
		retlw	h'6d'		;ASCII for m
		retlw	h'70'		;ASCII for p
		retlw	h'a5'		;ASCII for .
		retlw	h'fe'		;ASCII for blank
		retlw	h'3a'		;ASCII for :
		retlw	h'fe'		;ASCII for blank
		





;***************  12 microseconds timer *****************
t12us
        goto   $+1
        goto   $+1
        goto   $+1
        goto   $+1
        nop
        return


     
present    
	
     movlw b'01001001'     ;set clk 2 fosc/8,ADON,i/p channel ra1
     movwf ADCON0
     call  mscounter 
     bsf ADCON0,2          ;set GO bit to start ADC
   	 RETURN

CHECK    
     btfsc ADCON0,2     ;when conversion is complete ADCON0 will
    					;be cleared and control will come out of loop	   
   	 goto CHECK  
     MOVF ADRES,W       ;the ADC value is found in ADRES
     MOVWF AD1 
     SUBLW D'255'       ;255-ADRES
     MOVWF FIN
     bcf STATUS,0
     RLF FIN,W          ;(255-ADRES)*2
     MOVWF CONFU
	 MOVLW D'100'       ;2 extract hundreds value
	 SUBWF CONFU,W
	 CLRF A
	 CLRF B3
	 CLRF C3
	 CLRF COUNT
	 CLRF COUNT1
	 RETURN
	
	

HUNDREDS
	
	INCFSZ COUNT1,F     ;2 count hundreds subtract from 100 until 
						;borrow is generated.	
	MOVLW D'100'
	SUBWF CONFU,F
	BTFSC STATUS,0
	goto HUNDREDS
	MOVLW D'1'
	SUBWF COUNT1,W
	MOVWF A
	MOVLW D'100'
	ADDWF CONFU,F       ;the difference obtained should be added with
						;100 so as to extract the tens place  
	RETURN

TENS

	INCFSZ COUNT,F      ;2 count tens subtract from 10
	MOVLW D'10'
	SUBWF CONFU,F
	BTFSC STATUS,0
	GOTO TENS
	MOVLW D'10'
	ADDWF CONFU,W
	MOVWF C3           ;ones place-difference+10 gives ones place
	MOVLW D'1'
	SUBWF COUNT,W
	MOVWF B3		  ;tens place-count gives tens place							
	RETURN
	
;temp in kevin =500 -(255-ADRES)*2	
;******subtraction from 500 is done by digitwise subtraction
;various cases are to be considered inorder to initiate subtraction

SUBTRACT
	
	MOVLW D'10'                 
	MOVWF C1
	MOVLW D'9'
	MOVWF B1
	MOVLW D'4'
	MOVWF A1
	MOVLW D'0'
	XORWF C3,W
	BTFSC STATUS,Z
	GOTO UNIT       ;if ones place is 0,B1 should be made 10      
    MOVF C3,W
	SUBWF C1,W
	MOVWF C2
    MOVLW D'0'
    XORWF B3,W
    BTFSC STATUS,Z
    GOTO TEN        ;if tens place is 0 
    MOVF B3,W
    SUBWF B1,W
    MOVWF B2
    MOVF A,W
    SUBWF A1,W
    MOVWF A2
    GOTO DISPLAY1
	
	    
UNIT        ;*when units place is zero and tens place is nonzero
       CLRF C2
       MOVLW D'0'
       XORWF B3,W
       BTFSC STATUS,Z
       GOTO UNITY    ;in case tens place is 0,A1 should be made 5    
       INCF B1,F
       MOVF B3,W
       SUBWF B1,w
       MOVWF B2
       MOVF A,W
       SUBWF A1,W
       MOVWF A2
       GOTO DISPLAY1
    
UNITY       ;*when units place and tens place are both zeroes
       CLRF B2
       INCF A1,F    ;make A1=5
       MOVF A,W
       SUBWF A1,W
       MOVWF A2
       GOTO DISPLAY1
        
TEN      ;*when tens place is zero and units place is nonzero
    
       MOVF B3,W
       SUBWF B1,W
       MOVWF B2  
       MOVF A,W
       SUBWF A1,W
       MOVWF A2
       GOTO DISPLAY1      
    
    
DISPLAY1                   ;*to display the nos. on LCD
   
    
		bsf	porta,RS		;RS  line to 1 to i/p Data
		bcf porta,RW		;R/W line to 0 to write
		MOVLW D'48'
		ADDWF A2,F
		movf A2,W
		movwf portc			;send character to LCD
		call pulse_e		;Clock the LCD
		call	t48us		;delay for LCD busy
		
		
		bsf	porta,RS		;RS  line to 1 to i/p Data
		bcf porta,RW		;R/W line to 0 to write
		MOVLW D'48'
		ADDWF B2,F
		movf B2,W
		movwf portc		;send character to LCD
		call pulse_e	;Clock the LCD
		call t48us
		
		
		
		bsf	porta,RS		;RS  line to 1 to i/p Data
		bcf porta,RW		;R/W line to 0 to write
		MOVLW D'48'
		ADDWF C2,F
		movf C2,W
		movwf portc			;send character to LCD
		call pulse_e		;Clock the LCD
		call t48us
		
		
		bsf	porta,RS		;RS  line to 1 to i/p Data
		bcf porta,RW		;R/W line to 0 to write
		MOVLW b'11011111'   ;to print symbol for degree
		movwf portc			;send character to LCD
		call pulse_e		;Clock the LCD
		call t48us
		
		
		bsf	porta,RS		;RS  line to 1 to i/p Data
		bcf porta,RW		;R/W line to 0 to write
		MOVLW 'K'
		movwf portc			;send character to LCD
		call pulse_e		;Clock the LCD
		call t48us


;*to give the set-point value follow the same procedure as above
user_defined	
	
	 
 	    movlw b'01011001' ;set clk 2 fosc/8,ADON,i/p channel ra3
        movwf ADCON0
        call  mscounter 
       	bsf ADCON0,2 
CHECK1    
        btfsc ADCON0,2
        goto CHECK1  
        MOVF ADRES,W
        MOVWF ADUSER 
  	    SUBLW D'255'
        MOVWF FIN
        bcf STATUS,0
        RLF FIN,W
        MOVWF CONFU
	    MOVLW D'100'     ;2 extract hundreds value
	    SUBWF CONFU,W
	    CLRF A
	    CLRF B3
	    CLRF C3
	    clrf COUNT
	    CLRF COUNT1
	    BTFSC STATUS,0
	    CALL HUNDREDS1
	    CALL TENS1
	    GOTO SUBTRACT1
		
	

HUNDREDS1
	   INCFSZ COUNT1,F   ;2 count hundreds
	   MOVLW D'100'
	   SUBWF CONFU,F
	   BTFSC STATUS,0
	   goto HUNDREDS1
	   MOVLW D'1'
	   SUBWF COUNT1,W
	   MOVWF A
	   MOVLW D'100'
	   ADDWF CONFU,F  
	   RETURN
	
TENS1
	   INCFSZ COUNT,F    ;2 count tens
	   MOVLW D'10'
	   SUBWF CONFU,F
	   BTFSC STATUS,0
	   GOTO TENS1
	   MOVLW D'10'
	   ADDWF CONFU,W
	   MOVWF C3          ;ones place
	   MOVLW D'1'
	   SUBWF COUNT,W
	   MOVWF B3
 	
SUBTRACT1
	
	MOVLW D'10'
	MOVWF C1
	MOVLW D'9'
	MOVWF B1
	MOVLW D'4'
	MOVWF A1
	MOVLW D'0'
	XORWF C3,W
	BTFSC STATUS,Z
	GOTO UNIT1      ;in case tens place is 0,B1 should be made 10  
	MOVF C3,W
	SUBWF C1,W
	MOVWF C2
    MOVLW D'0'
    XORWF B3,W
    BTFSC STATUS,Z
    GOTO TEN1       ;in case tens place is 0 ,A1 should be made 5      
    MOVF B3,W
    SUBWF B1,W
    MOVWF B2
    MOVF A,W
    SUBWF A1,W
    MOVWF A2
    GOTO DISPLAY2
           
UNIT1           ;*when units place is zero
    CLRF C2
    MOVLW D'0'
    XORWF B3,W
    BTFSC STATUS,Z
    GOTO UNITY1
    INCF B1,F
    MOVF B3,W
    SUBWF B1,w
    MOVWF B2
    MOVF A,W
    SUBWF A1,W
    MOVWF A2
    GOTO DISPLAY2
    
UNITY1          ;*when units place and tens place are both zeroes
    CLRF B2
    INCF A1,F
    MOVF A,W
    SUBWF A1,W
    MOVWF A2
    GOTO DISPLAY2
        
TEN1           ;*when tens place is zero and units place is nonzero
     
    
    MOVF B3,W
    SUBWF B1,W
    MOVWF B2  
    MOVF A,W
    SUBWF A1,W
    MOVWF A2
   	GOTO DISPLAY2      
   	

     	
DISPLAY2
   		bcf	porta,RS		
		bcf porta,RW		
		movlw	h'a8'			;TO GOTO SECOND LINE
		movwf	portc			
		call 	pulse_e			
		call	t48us
		
		bsf	porta,RS		;RS  line to 1 to i/p Data
		bcf porta,RW		;R/W line to 0 to write
		MOVLW 'S'
		movwf portc			;send character to LCD
		call pulse_e		;Clock the LCD
		call t48us
		
		
		bsf	porta,RS		;RS  line to 1 to i/p Data
		bcf porta,RW		;R/W line to 0 to write
		MOVLW 'e'
		movwf portc			;send character to LCD
		call pulse_e		;Clock the LCD
		call t48us
		
		
		bsf	porta,RS		;RS  line to 1 to i/p Data
		bcf porta,RW		;R/W line to 0 to write
		MOVLW 't'
		movwf portc			;send character to LCD
		call pulse_e		;Clock the LCD
		call t48us
		
		
		
		bsf	porta,RS		;RS  line to 1 to i/p Data
		bcf porta,RW		;R/W line to 0 to write
		MOVLW H'FE'
		movwf portc			;send character to LCD
		call pulse_e		;Clock the LCD
		call t48us	
		
		bsf	porta,RS		;RS  line to 1 to i/p Data
		bcf porta,RW		;R/W line to 0 to write
		MOVLW 'P'
		movwf portc			;send character to LCD
		call pulse_e		;Clock the LCD
		call t48us
		
		bsf	porta,RS		;RS  line to 1 to i/p Data
		bcf porta,RW		;R/W line to 0 to write
		MOVLW 'o'
		movwf portc			;send character to LCD
		call pulse_e		;Clock the LCD
		call t48us
		
		
		bsf	porta,RS		;RS  line to 1 to i/p Data
		bcf porta,RW		;R/W line to 0 to write
		MOVLW 'i'
		movwf portc			;send character to LCD
		call pulse_e		;Clock the LCD
		call t48us
		
		bsf	porta,RS		;RS  line to 1 to i/p Data
		bcf porta,RW		;R/W line to 0 to write
		MOVLW 'n'
		movwf portc			;send character to LCD
		call pulse_e		;Clock the LCD
		call t48us
		
		
		bsf	porta,RS		;RS  line to 1 to i/p Data
		bcf porta,RW		;R/W line to 0 to write
		MOVLW 't'
		movwf portc			;send character to LCD
		call pulse_e		;Clock the LCD
		call t48us
		
		
		bsf	porta,RS		;RS  line to 1 to i/p Data
		bcf porta,RW		;R/W line to 0 to write
		MOVLW ':'
		movwf portc			;send character to LCD
		call pulse_e		;Clock the LCD
		call t48us
		
		bsf	porta,RS		;RS  line to 1 to i/p Data
		bcf porta,RW		;R/W line to 0 to write
		MOVLW h'fe'
		movwf portc			;send character to LCD
		call pulse_e		;Clock the LCD
		call t48us
		
		
		bsf	porta,RS		;RS  line to 1 to i/p Data
		bcf porta,RW		;R/W line to 0 to write
		MOVLW D'48'
		ADDWF A2,F
		movf A2,W
		movwf portc			;send character to LCD
		call pulse_e		;Clock the LCD
		call t48us			;delay for LCD busy
		
		
		bsf	porta,RS		;RS  line to 1 to i/p Data
		bcf porta,RW		;R/W line to 0 to write
		MOVLW D'48'
		ADDWF B2,F
		movf B2,W
		movwf portc		;send character to LCD
		call pulse_e	;Clock the LCD
		call t48us
		
		
		
		bsf	porta,RS		;RS  line to 1 to i/p Data
		bcf porta,RW		;R/W line to 0 to write
		MOVLW D'48'
		ADDWF C2,F
		movf C2,W
		movwf portc			;send character to LCD
		call pulse_e		;Clock the LCD
		call t48us
		
		
		bsf	porta,RS		;RS  line to 1 to i/p Data
		bcf porta,RW		;R/W line to 0 to write
		MOVLW b'11011111'   ;to print symbol for degree
		movwf portc			;send character to LCD
		call pulse_e		;Clock the LCD
		call t48us
		
		
		bsf	porta,RS		;RS  line to 1 to i/p Data
		bcf porta,RW		;R/W line to 0 to write
		MOVLW 'K'
		movwf portc			;send character to LCD
		call pulse_e		;Clock the LCD
		call t48us	  
	        	  
   
   
  ;****to generate the ON/OFF signal subtract ADUSER from AD1 	       
CONTROL
	
       MOVF AD1,W
       SUBWF ADUSER,W
       BTFSC STATUS,0
       GOTO CONTROL1
       BCF PORTB,1
       goto cursor1

CONTROL1
	  BTFSC STATUS,Z
	  goto clear             ;To give the OFF signal
      BSF PORTB,1	         ;To give the ON signal  
      goto cursor1

clear
	bcf PORTB,1
	goto cursor1   
	


cursor1   ;*********to give cursor home command to LCD
	
		bcf		porta,RS		
		bcf 	porta,RW		
		movlw	h'03'			
		movwf	portc			 
		call	pulse_e			
		call	t48us	
		goto begin

int

	goto mainline
	
    END

;*****END OF PROGRAM CODE **

